#include <stdio.h>
#include <stdlib.h>

int main()
{
  long value;
  char *p, *endptr;

  p = "";
  value = strtol(p, &endptr, 0);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "@@@";
  value = strtol(p, &endptr, 0);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "   12345";
  value = strtol(p, &endptr, 0);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "12345@@@";
  value = strtol(p, &endptr, 0);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "0";
  value = strtol(p, &endptr, 0);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "10";
  value = strtol(p, &endptr, 0);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "12345";
  value = strtol(p, &endptr, 0);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "-12345";
  value = strtol(p, &endptr, 0);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "12345";
  value = strtol(p, &endptr, 10);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "-12345";
  value = strtol(p, &endptr, 10);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "01234";
  value = strtol(p, &endptr, 0);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "01234";
  value = strtol(p, &endptr, 8);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "1234";
  value = strtol(p, &endptr, 8);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "0x1234abcd";
  value = strtol(p, &endptr, 0);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "0x1234ABCD";
  value = strtol(p, &endptr, 0);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "0X1234ABCD";
  value = strtol(p, &endptr, 0);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "0x1234abcd";
  value = strtol(p, &endptr, 16);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "0x1234ABCD";
  value = strtol(p, &endptr, 16);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "1234abcd";
  value = strtol(p, &endptr, 16);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "ghijkl";
  value = strtol(p, &endptr, 16);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "ghijkl";
  value = strtol(p, &endptr, 20);
  printf("%ld %d\n", value, (int)(endptr - p));

  p = "ghijkl";
  value = strtol(p, &endptr, 24);
  printf("%ld %d\n", value, (int)(endptr - p));

  return 0;
}
